/**
 */
package eu.chorevolution.modelingnotations.security;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>XACML Function</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see eu.chorevolution.modelingnotations.security.SecurityPackage#getXACMLFunction()
 * @model
 * @generated
 */
public enum XACMLFunction implements Enumerator {
	/**
	 * The '<em><b>String equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STRING_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	STRING_EQUAL(0, "string_equal", "string_equal"),

	/**
	 * The '<em><b>Boolean equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #BOOLEAN_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	BOOLEAN_EQUAL(1, "boolean_equal", "boolean_equal"),

	/**
	 * The '<em><b>Integer equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INTEGER_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	INTEGER_EQUAL(2, "integer_equal", "integer_equal"),

	/**
	 * The '<em><b>Double equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DOUBLE_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	DOUBLE_EQUAL(3, "double_equal", "double_equal"),

	/**
	 * The '<em><b>Date equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DATE_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	DATE_EQUAL(4, "date_equal", "date_equal"),

	/**
	 * The '<em><b>Time equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIME_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	TIME_EQUAL(5, "time_equal", "time_equal"),

	/**
	 * The '<em><b>String equal ignore case</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STRING_EQUAL_IGNORE_CASE_VALUE
	 * @generated
	 * @ordered
	 */
	STRING_EQUAL_IGNORE_CASE(6, "string_equal_ignore_case", "string_equal_ignore_case"),

	/**
	 * The '<em><b>Integer greater than</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INTEGER_GREATER_THAN_VALUE
	 * @generated
	 * @ordered
	 */
	INTEGER_GREATER_THAN(7, "integer_greater_than", "integer_greater_than"),

	/**
	 * The '<em><b>Integer greater than or equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INTEGER_GREATER_THAN_OR_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	INTEGER_GREATER_THAN_OR_EQUAL(8, "integer_greater_than_or_equal", "integer_greater_than_or_equal"),

	/**
	 * The '<em><b>Integer less than</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INTEGER_LESS_THAN_VALUE
	 * @generated
	 * @ordered
	 */
	INTEGER_LESS_THAN(9, "integer_less_than", "integer_less_than"),

	/**
	 * The '<em><b>Integer less than or equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INTEGER_LESS_THAN_OR_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	INTEGER_LESS_THAN_OR_EQUAL(10, "integer_less_than_or_equal", "integer_less_than_or_equal"),

	/**
	 * The '<em><b>Double greater than</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DOUBLE_GREATER_THAN_VALUE
	 * @generated
	 * @ordered
	 */
	DOUBLE_GREATER_THAN(11, "double_greater_than", "double_greater_than"),

	/**
	 * The '<em><b>Double greater than or equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DOUBLE_GREATER_THAN_OR_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	DOUBLE_GREATER_THAN_OR_EQUAL(12, "double_greater_than_or_equal", "double_greater_than_or_equal"),

	/**
	 * The '<em><b>Double less than</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DOUBLE_LESS_THAN_VALUE
	 * @generated
	 * @ordered
	 */
	DOUBLE_LESS_THAN(13, "double_less_than", "double_less_than"),

	/**
	 * The '<em><b>Double less than or equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DOUBLE_LESS_THAN_OR_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	DOUBLE_LESS_THAN_OR_EQUAL(14, "double_less_than_or_equal", "double_less_than_or_equal"),

	/**
	 * The '<em><b>String greater than</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STRING_GREATER_THAN_VALUE
	 * @generated
	 * @ordered
	 */
	STRING_GREATER_THAN(15, "string_greater_than", "string_greater_than"),

	/**
	 * The '<em><b>String greater than or equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STRING_GREATER_THAN_OR_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	STRING_GREATER_THAN_OR_EQUAL(16, "string_greater_than_or_equal", "string_greater_than_or_equal"),

	/**
	 * The '<em><b>String less than</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STRING_LESS_THAN_VALUE
	 * @generated
	 * @ordered
	 */
	STRING_LESS_THAN(17, "string_less_than", "string_less_than"),

	/**
	 * The '<em><b>String less than or equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STRING_LESS_THAN_OR_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	STRING_LESS_THAN_OR_EQUAL(18, "string_less_than_or_equal", "string_less_than_or_equal"),

	/**
	 * The '<em><b>Time greater than</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIME_GREATER_THAN_VALUE
	 * @generated
	 * @ordered
	 */
	TIME_GREATER_THAN(19, "time_greater_than", "time_greater_than"),

	/**
	 * The '<em><b>Time greater than or equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIME_GREATER_THAN_OR_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	TIME_GREATER_THAN_OR_EQUAL(20, "time_greater_than_or_equal", "time_greater_than_or_equal"),

	/**
	 * The '<em><b>Time less than</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIME_LESS_THAN_VALUE
	 * @generated
	 * @ordered
	 */
	TIME_LESS_THAN(21, "time_less_than", "time_less_than"),

	/**
	 * The '<em><b>Time less than or equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TIME_LESS_THAN_OR_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	TIME_LESS_THAN_OR_EQUAL(22, "time_less_than_or_equal", "time_less_than_or_equal"),

	/**
	 * The '<em><b>Date greater than</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DATE_GREATER_THAN_VALUE
	 * @generated
	 * @ordered
	 */
	DATE_GREATER_THAN(23, "date_greater_than", "date_greater_than"),

	/**
	 * The '<em><b>Date greater than or equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DATE_GREATER_THAN_OR_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	DATE_GREATER_THAN_OR_EQUAL(24, "date_greater_than_or_equal", "date_greater_than_or_equal"),

	/**
	 * The '<em><b>Date less than</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DATE_LESS_THAN_VALUE
	 * @generated
	 * @ordered
	 */
	DATE_LESS_THAN(25, "date_less_than", "date_less_than"),

	/**
	 * The '<em><b>Date less than or equal</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DATE_LESS_THAN_OR_EQUAL_VALUE
	 * @generated
	 * @ordered
	 */
	DATE_LESS_THAN_OR_EQUAL(26, "date_less_than_or_equal", "date_less_than_or_equal"),

	/**
	 * The '<em><b>String starts with</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STRING_STARTS_WITH_VALUE
	 * @generated
	 * @ordered
	 */
	STRING_STARTS_WITH(27, "string_starts_with", "string_starts_with"),

	/**
	 * The '<em><b>String ends with</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STRING_ENDS_WITH_VALUE
	 * @generated
	 * @ordered
	 */
	STRING_ENDS_WITH(28, "string_ends_with", "string_ends_with"),

	/**
	 * The '<em><b>String contains</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STRING_CONTAINS_VALUE
	 * @generated
	 * @ordered
	 */
	STRING_CONTAINS(29, "string_contains", "string_contains");

	/**
	 * The '<em><b>String equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STRING_EQUAL
	 * @model name="string_equal"
	 * @generated
	 * @ordered
	 */
	public static final int STRING_EQUAL_VALUE = 0;

	/**
	 * The '<em><b>Boolean equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Boolean equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #BOOLEAN_EQUAL
	 * @model name="boolean_equal"
	 * @generated
	 * @ordered
	 */
	public static final int BOOLEAN_EQUAL_VALUE = 1;

	/**
	 * The '<em><b>Integer equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Integer equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INTEGER_EQUAL
	 * @model name="integer_equal"
	 * @generated
	 * @ordered
	 */
	public static final int INTEGER_EQUAL_VALUE = 2;

	/**
	 * The '<em><b>Double equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Double equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DOUBLE_EQUAL
	 * @model name="double_equal"
	 * @generated
	 * @ordered
	 */
	public static final int DOUBLE_EQUAL_VALUE = 3;

	/**
	 * The '<em><b>Date equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Date equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DATE_EQUAL
	 * @model name="date_equal"
	 * @generated
	 * @ordered
	 */
	public static final int DATE_EQUAL_VALUE = 4;

	/**
	 * The '<em><b>Time equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Time equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIME_EQUAL
	 * @model name="time_equal"
	 * @generated
	 * @ordered
	 */
	public static final int TIME_EQUAL_VALUE = 5;

	/**
	 * The '<em><b>String equal ignore case</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String equal ignore case</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STRING_EQUAL_IGNORE_CASE
	 * @model name="string_equal_ignore_case"
	 * @generated
	 * @ordered
	 */
	public static final int STRING_EQUAL_IGNORE_CASE_VALUE = 6;

	/**
	 * The '<em><b>Integer greater than</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Integer greater than</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INTEGER_GREATER_THAN
	 * @model name="integer_greater_than"
	 * @generated
	 * @ordered
	 */
	public static final int INTEGER_GREATER_THAN_VALUE = 7;

	/**
	 * The '<em><b>Integer greater than or equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Integer greater than or equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INTEGER_GREATER_THAN_OR_EQUAL
	 * @model name="integer_greater_than_or_equal"
	 * @generated
	 * @ordered
	 */
	public static final int INTEGER_GREATER_THAN_OR_EQUAL_VALUE = 8;

	/**
	 * The '<em><b>Integer less than</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Integer less than</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INTEGER_LESS_THAN
	 * @model name="integer_less_than"
	 * @generated
	 * @ordered
	 */
	public static final int INTEGER_LESS_THAN_VALUE = 9;

	/**
	 * The '<em><b>Integer less than or equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Integer less than or equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INTEGER_LESS_THAN_OR_EQUAL
	 * @model name="integer_less_than_or_equal"
	 * @generated
	 * @ordered
	 */
	public static final int INTEGER_LESS_THAN_OR_EQUAL_VALUE = 10;

	/**
	 * The '<em><b>Double greater than</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Double greater than</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DOUBLE_GREATER_THAN
	 * @model name="double_greater_than"
	 * @generated
	 * @ordered
	 */
	public static final int DOUBLE_GREATER_THAN_VALUE = 11;

	/**
	 * The '<em><b>Double greater than or equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Double greater than or equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DOUBLE_GREATER_THAN_OR_EQUAL
	 * @model name="double_greater_than_or_equal"
	 * @generated
	 * @ordered
	 */
	public static final int DOUBLE_GREATER_THAN_OR_EQUAL_VALUE = 12;

	/**
	 * The '<em><b>Double less than</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Double less than</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DOUBLE_LESS_THAN
	 * @model name="double_less_than"
	 * @generated
	 * @ordered
	 */
	public static final int DOUBLE_LESS_THAN_VALUE = 13;

	/**
	 * The '<em><b>Double less than or equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Double less than or equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DOUBLE_LESS_THAN_OR_EQUAL
	 * @model name="double_less_than_or_equal"
	 * @generated
	 * @ordered
	 */
	public static final int DOUBLE_LESS_THAN_OR_EQUAL_VALUE = 14;

	/**
	 * The '<em><b>String greater than</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String greater than</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STRING_GREATER_THAN
	 * @model name="string_greater_than"
	 * @generated
	 * @ordered
	 */
	public static final int STRING_GREATER_THAN_VALUE = 15;

	/**
	 * The '<em><b>String greater than or equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String greater than or equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STRING_GREATER_THAN_OR_EQUAL
	 * @model name="string_greater_than_or_equal"
	 * @generated
	 * @ordered
	 */
	public static final int STRING_GREATER_THAN_OR_EQUAL_VALUE = 16;

	/**
	 * The '<em><b>String less than</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String less than</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STRING_LESS_THAN
	 * @model name="string_less_than"
	 * @generated
	 * @ordered
	 */
	public static final int STRING_LESS_THAN_VALUE = 17;

	/**
	 * The '<em><b>String less than or equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String less than or equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STRING_LESS_THAN_OR_EQUAL
	 * @model name="string_less_than_or_equal"
	 * @generated
	 * @ordered
	 */
	public static final int STRING_LESS_THAN_OR_EQUAL_VALUE = 18;

	/**
	 * The '<em><b>Time greater than</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Time greater than</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIME_GREATER_THAN
	 * @model name="time_greater_than"
	 * @generated
	 * @ordered
	 */
	public static final int TIME_GREATER_THAN_VALUE = 19;

	/**
	 * The '<em><b>Time greater than or equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Time greater than or equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIME_GREATER_THAN_OR_EQUAL
	 * @model name="time_greater_than_or_equal"
	 * @generated
	 * @ordered
	 */
	public static final int TIME_GREATER_THAN_OR_EQUAL_VALUE = 20;

	/**
	 * The '<em><b>Time less than</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Time less than</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIME_LESS_THAN
	 * @model name="time_less_than"
	 * @generated
	 * @ordered
	 */
	public static final int TIME_LESS_THAN_VALUE = 21;

	/**
	 * The '<em><b>Time less than or equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Time less than or equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TIME_LESS_THAN_OR_EQUAL
	 * @model name="time_less_than_or_equal"
	 * @generated
	 * @ordered
	 */
	public static final int TIME_LESS_THAN_OR_EQUAL_VALUE = 22;

	/**
	 * The '<em><b>Date greater than</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Date greater than</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DATE_GREATER_THAN
	 * @model name="date_greater_than"
	 * @generated
	 * @ordered
	 */
	public static final int DATE_GREATER_THAN_VALUE = 23;

	/**
	 * The '<em><b>Date greater than or equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Date greater than or equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DATE_GREATER_THAN_OR_EQUAL
	 * @model name="date_greater_than_or_equal"
	 * @generated
	 * @ordered
	 */
	public static final int DATE_GREATER_THAN_OR_EQUAL_VALUE = 24;

	/**
	 * The '<em><b>Date less than</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Date less than</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DATE_LESS_THAN
	 * @model name="date_less_than"
	 * @generated
	 * @ordered
	 */
	public static final int DATE_LESS_THAN_VALUE = 25;

	/**
	 * The '<em><b>Date less than or equal</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Date less than or equal</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DATE_LESS_THAN_OR_EQUAL
	 * @model name="date_less_than_or_equal"
	 * @generated
	 * @ordered
	 */
	public static final int DATE_LESS_THAN_OR_EQUAL_VALUE = 26;

	/**
	 * The '<em><b>String starts with</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String starts with</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STRING_STARTS_WITH
	 * @model name="string_starts_with"
	 * @generated
	 * @ordered
	 */
	public static final int STRING_STARTS_WITH_VALUE = 27;

	/**
	 * The '<em><b>String ends with</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String ends with</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STRING_ENDS_WITH
	 * @model name="string_ends_with"
	 * @generated
	 * @ordered
	 */
	public static final int STRING_ENDS_WITH_VALUE = 28;

	/**
	 * The '<em><b>String contains</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String contains</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STRING_CONTAINS
	 * @model name="string_contains"
	 * @generated
	 * @ordered
	 */
	public static final int STRING_CONTAINS_VALUE = 29;

	/**
	 * An array of all the '<em><b>XACML Function</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final XACMLFunction[] VALUES_ARRAY =
		new XACMLFunction[] {
			STRING_EQUAL,
			BOOLEAN_EQUAL,
			INTEGER_EQUAL,
			DOUBLE_EQUAL,
			DATE_EQUAL,
			TIME_EQUAL,
			STRING_EQUAL_IGNORE_CASE,
			INTEGER_GREATER_THAN,
			INTEGER_GREATER_THAN_OR_EQUAL,
			INTEGER_LESS_THAN,
			INTEGER_LESS_THAN_OR_EQUAL,
			DOUBLE_GREATER_THAN,
			DOUBLE_GREATER_THAN_OR_EQUAL,
			DOUBLE_LESS_THAN,
			DOUBLE_LESS_THAN_OR_EQUAL,
			STRING_GREATER_THAN,
			STRING_GREATER_THAN_OR_EQUAL,
			STRING_LESS_THAN,
			STRING_LESS_THAN_OR_EQUAL,
			TIME_GREATER_THAN,
			TIME_GREATER_THAN_OR_EQUAL,
			TIME_LESS_THAN,
			TIME_LESS_THAN_OR_EQUAL,
			DATE_GREATER_THAN,
			DATE_GREATER_THAN_OR_EQUAL,
			DATE_LESS_THAN,
			DATE_LESS_THAN_OR_EQUAL,
			STRING_STARTS_WITH,
			STRING_ENDS_WITH,
			STRING_CONTAINS,
		};

	/**
	 * A public read-only list of all the '<em><b>XACML Function</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<XACMLFunction> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>XACML Function</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static XACMLFunction get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			XACMLFunction result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>XACML Function</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static XACMLFunction getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			XACMLFunction result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>XACML Function</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static XACMLFunction get(int value) {
		switch (value) {
			case STRING_EQUAL_VALUE: return STRING_EQUAL;
			case BOOLEAN_EQUAL_VALUE: return BOOLEAN_EQUAL;
			case INTEGER_EQUAL_VALUE: return INTEGER_EQUAL;
			case DOUBLE_EQUAL_VALUE: return DOUBLE_EQUAL;
			case DATE_EQUAL_VALUE: return DATE_EQUAL;
			case TIME_EQUAL_VALUE: return TIME_EQUAL;
			case STRING_EQUAL_IGNORE_CASE_VALUE: return STRING_EQUAL_IGNORE_CASE;
			case INTEGER_GREATER_THAN_VALUE: return INTEGER_GREATER_THAN;
			case INTEGER_GREATER_THAN_OR_EQUAL_VALUE: return INTEGER_GREATER_THAN_OR_EQUAL;
			case INTEGER_LESS_THAN_VALUE: return INTEGER_LESS_THAN;
			case INTEGER_LESS_THAN_OR_EQUAL_VALUE: return INTEGER_LESS_THAN_OR_EQUAL;
			case DOUBLE_GREATER_THAN_VALUE: return DOUBLE_GREATER_THAN;
			case DOUBLE_GREATER_THAN_OR_EQUAL_VALUE: return DOUBLE_GREATER_THAN_OR_EQUAL;
			case DOUBLE_LESS_THAN_VALUE: return DOUBLE_LESS_THAN;
			case DOUBLE_LESS_THAN_OR_EQUAL_VALUE: return DOUBLE_LESS_THAN_OR_EQUAL;
			case STRING_GREATER_THAN_VALUE: return STRING_GREATER_THAN;
			case STRING_GREATER_THAN_OR_EQUAL_VALUE: return STRING_GREATER_THAN_OR_EQUAL;
			case STRING_LESS_THAN_VALUE: return STRING_LESS_THAN;
			case STRING_LESS_THAN_OR_EQUAL_VALUE: return STRING_LESS_THAN_OR_EQUAL;
			case TIME_GREATER_THAN_VALUE: return TIME_GREATER_THAN;
			case TIME_GREATER_THAN_OR_EQUAL_VALUE: return TIME_GREATER_THAN_OR_EQUAL;
			case TIME_LESS_THAN_VALUE: return TIME_LESS_THAN;
			case TIME_LESS_THAN_OR_EQUAL_VALUE: return TIME_LESS_THAN_OR_EQUAL;
			case DATE_GREATER_THAN_VALUE: return DATE_GREATER_THAN;
			case DATE_GREATER_THAN_OR_EQUAL_VALUE: return DATE_GREATER_THAN_OR_EQUAL;
			case DATE_LESS_THAN_VALUE: return DATE_LESS_THAN;
			case DATE_LESS_THAN_OR_EQUAL_VALUE: return DATE_LESS_THAN_OR_EQUAL;
			case STRING_STARTS_WITH_VALUE: return STRING_STARTS_WITH;
			case STRING_ENDS_WITH_VALUE: return STRING_ENDS_WITH;
			case STRING_CONTAINS_VALUE: return STRING_CONTAINS;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private XACMLFunction(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //XACMLFunction
